﻿$(document).ready(() => {
    let id = null;

    function UpdateMainButtonsUI() {
        if (id == null) {
            $("#btnOpen").attr("disabled", true);
            $("#btnArchive").attr("disabled", true);
        }
        else {
            $("#btnOpen").attr("disabled", false);
            $("#btnArchive").attr("disabled", false);
        }
    }

    function AttachEventsMainTable() {
        var header = document.getElementById("servicesHead");                 //for sticky head
        var sticky = header.offsetTop;

        //event for show go top button
        $(window).on("scroll", function () {
            //for sticky head
            if (window.pageYOffset > (sticky + 100)) {
                header.classList.add("sticky");
            } else {
                header.classList.remove("sticky");
            }
        });

        /*table events*/
        $('#tariscope-issues tbody').on('click', 'tr', function () {
            if ($(this).hasClass('selected')) {
                $(this).removeClass('selected');
                id = null;
            }
            else {
                id = $(this).find('td[data-name="ID"]').text();
                $('#tariscope-issues tr.selected').removeClass('selected');
                $(this).addClass('selected');
            }

            UpdateMainButtonsUI();
        });

        UpdateMainButtonsUI();
    }

    function LoadTable() {
        id = null;
        $('#issuesTable').load('/PersonalArea/Service/Issues/Load', AttachEventsMainTable);
    }

    //open archive
    $('#btnOpenArchive').on('click', () => { window.open('/PersonalArea/Service/Issues/Archive', '_parent'); });

    //open char
    $('#btnOpen').on('click', () => { window.open('/PersonalArea/Service/Issues/Chat/' + id, '_parent'); });

    //show modal to mode into archive
    $('#btnArchive').on('click', () => { $('#confirmArchiveModal').modal('show'); });

    //confirm archive the issue
    $('#ConfrimMoveBtn').on('click', () => {
        $('#confirmArchiveModal').modal('hide');
        ShowSpinner(true);

        $.ajax({
            type: "POST",
            url: '/PersonalArea/Service/Issues/Status/' + id,
            success: function (response) {
                if (response != null && response.success == true) {
                    $.ajax({
                        type: "POST",
                        url: '/PersonalArea/Service/Issues/Archive/' + id,
                        success: function (response) {
                            ShowSpinner(false);
                            LoadTable();
                        }
                    });
                }
                else {
                    ShowSpinner(false);
                    $('#ErrorArchiveModal').modal('show');
                }
            }
        });
    });

    //create issue
    $('#btnAdd').on('click', () => { window.open('/PersonalArea/Service/Issues/Create', '_parent'); });

    LoadTable();
});